from PyQt5 import QtCore, QtGui, QtWidgets
from matplotlib.backends.backend_qt5agg import FigureCanvasQTAgg as FigureCanvas
from matplotlib.figure import Figure
import serial.tools.list_ports


class Ui_MainWindow(object):
    def setupUi(self, MainWindow):
        MainWindow.setObjectName("MainWindow")
        MainWindow.resize(1903, 1065)
        sizePolicy = QtWidgets.QSizePolicy(QtWidgets.QSizePolicy.Ignored, QtWidgets.QSizePolicy.Ignored)
        sizePolicy.setHorizontalStretch(50)
        sizePolicy.setVerticalStretch(50)
        sizePolicy.setHeightForWidth(MainWindow.sizePolicy().hasHeightForWidth())
        MainWindow.setSizePolicy(sizePolicy)
        font = QtGui.QFont()
        font.setFamily("Roboto")
        MainWindow.setFont(font)
        MainWindow.setStyleSheet("background-color: rgb(230, 230, 230);\n"
"")
        MainWindow.setToolButtonStyle(QtCore.Qt.ToolButtonIconOnly)
        self.centralwidget = QtWidgets.QWidget(MainWindow)
        self.centralwidget.setObjectName("centralwidget")
        self.frame = QtWidgets.QFrame(self.centralwidget)
        self.frame.setGeometry(QtCore.QRect(620, 100, 750, 750))
        font = QtGui.QFont()
        font.setFamily("Roboto")
        font.setPointSize(23)
        self.frame.setFont(font)
        self.frame.setStyleSheet("background-color: rgb(200, 200, 200)")
        self.frame.setFrameShape(QtWidgets.QFrame.StyledPanel)
        self.frame.setFrameShadow(QtWidgets.QFrame.Raised)
        self.frame.setObjectName("frame")
        self.checkBox = QtWidgets.QCheckBox(self.centralwidget)
        self.checkBox.setGeometry(QtCore.QRect(860, 780, 301, 51))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.checkBox.setFont(font)
        self.checkBox.setStyleSheet("color: rgb(50,50,50);\n"
"font-size: 40px;")
        self.checkBox.setObjectName("checkBox")
        self.label = QtWidgets.QLabel(self.centralwidget)
        self.label.setGeometry(QtCore.QRect(200, 560, 261, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label.setFont(font)
        self.label.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label.setObjectName("label")
        self.doubleSpinBox = QtWidgets.QDoubleSpinBox(self.centralwidget)
        self.doubleSpinBox.setGeometry(QtCore.QRect(90, 630, 111, 61))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.doubleSpinBox.setFont(font)
        self.doubleSpinBox.setStyleSheet("QDoubleSpinBox{\n"
"    color: rgb(50,50,50);\n"
"    border: 1px solid rgb(50, 50, 50);\n"
"    font-size: 25px;\n"
"}\n"
"")
        self.doubleSpinBox.setMinimum(-575.0)
        self.doubleSpinBox.setMaximum(575.0)
        self.doubleSpinBox.setObjectName("doubleSpinBox")
        self.doubleSpinBox_2 = QtWidgets.QDoubleSpinBox(self.centralwidget)
        self.doubleSpinBox_2.setGeometry(QtCore.QRect(270, 630, 111, 61))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.doubleSpinBox_2.setFont(font)
        self.doubleSpinBox_2.setStyleSheet("QDoubleSpinBox{\n"
"    color: rgb(50,50,50);\n"
"    border: 1px solid rgb(50, 50, 50);\n"
"    font-size: 25px;\n"
"}\n"
"")
        self.doubleSpinBox_2.setMinimum(-575.0)
        self.doubleSpinBox_2.setMaximum(575.0)
        self.doubleSpinBox_2.setObjectName("doubleSpinBox_2")
        self.doubleSpinBox_3 = QtWidgets.QDoubleSpinBox(self.centralwidget)
        self.doubleSpinBox_3.setGeometry(QtCore.QRect(450, 630, 111, 61))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.doubleSpinBox_3.setFont(font)
        self.doubleSpinBox_3.setStyleSheet("QDoubleSpinBox{\n"
"    color: rgb(50,50,50);\n"
"    border: 1px solid rgb(50, 50, 50);\n"
"    font-size: 25px;\n"
"}\n"
"")
        self.doubleSpinBox_3.setMinimum(-575.0)
        self.doubleSpinBox_3.setMaximum(575.0)
        self.doubleSpinBox_3.setObjectName("doubleSpinBox_3")
        self.label_2 = QtWidgets.QLabel(self.centralwidget)
        self.label_2.setGeometry(QtCore.QRect(50, 640, 31, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_2.setFont(font)
        self.label_2.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_2.setObjectName("label_2")
        self.label_3 = QtWidgets.QLabel(self.centralwidget)
        self.label_3.setGeometry(QtCore.QRect(230, 640, 31, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_3.setFont(font)
        self.label_3.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_3.setObjectName("label_3")
        self.label_4 = QtWidgets.QLabel(self.centralwidget)
        self.label_4.setGeometry(QtCore.QRect(410, 640, 31, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_4.setFont(font)
        self.label_4.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_4.setObjectName("label_4")
        self.label_6 = QtWidgets.QLabel(self.centralwidget)
        self.label_6.setGeometry(QtCore.QRect(230, 380, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_6.setFont(font)
        self.label_6.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_6.setObjectName("label_6")
        self.label_7 = QtWidgets.QLabel(self.centralwidget)
        self.label_7.setGeometry(QtCore.QRect(50, 380, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_7.setFont(font)
        self.label_7.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_7.setObjectName("label_7")
        self.doubleSpinBox_4 = QtWidgets.QDoubleSpinBox(self.centralwidget)
        self.doubleSpinBox_4.setGeometry(QtCore.QRect(270, 370, 111, 61))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.doubleSpinBox_4.setFont(font)
        self.doubleSpinBox_4.setStyleSheet("QDoubleSpinBox{\n"
"    color: rgb(50,50,50);\n"
"    border: 1px solid rgb(50, 50, 50);\n"
"    font-size: 25px;\n"
"}\n"
"")
        self.doubleSpinBox_4.setMinimum(-180.0)
        self.doubleSpinBox_4.setMaximum(180.0)
        self.doubleSpinBox_4.setObjectName("doubleSpinBox_4")
        self.label_8 = QtWidgets.QLabel(self.centralwidget)
        self.label_8.setGeometry(QtCore.QRect(410, 380, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_8.setFont(font)
        self.label_8.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_8.setObjectName("label_8")
        self.doubleSpinBox_5 = QtWidgets.QDoubleSpinBox(self.centralwidget)
        self.doubleSpinBox_5.setGeometry(QtCore.QRect(90, 370, 111, 61))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.doubleSpinBox_5.setFont(font)
        self.doubleSpinBox_5.setStyleSheet("QDoubleSpinBox{\n"
"    color: rgb(50,50,50);\n"
"    border: 1px solid rgb(50, 50, 50);\n"
"    font-size: 25px;\n"
"}\n"
"")
        self.doubleSpinBox_5.setMinimum(-180.0)
        self.doubleSpinBox_5.setMaximum(180.0)
        self.doubleSpinBox_5.setObjectName("doubleSpinBox_5")
        self.doubleSpinBox_6 = QtWidgets.QDoubleSpinBox(self.centralwidget)
        self.doubleSpinBox_6.setGeometry(QtCore.QRect(450, 370, 111, 61))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.doubleSpinBox_6.setFont(font)
        self.doubleSpinBox_6.setStyleSheet("QDoubleSpinBox{\n"
"    color: rgb(50,50,50);\n"
"    border: 1px solid rgb(50, 50, 50);\n"
"    font-size: 25px;\n"
"}\n"
"")
        self.doubleSpinBox_6.setMinimum(-180.0)
        self.doubleSpinBox_6.setMaximum(180.0)
        self.doubleSpinBox_6.setObjectName("doubleSpinBox_6")
        self.label_10 = QtWidgets.QLabel(self.centralwidget)
        self.label_10.setGeometry(QtCore.QRect(1580, 150, 171, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_10.setFont(font)
        self.label_10.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_10.setObjectName("label_10")
        self.label_11 = QtWidgets.QLabel(self.centralwidget)
        self.label_11.setGeometry(QtCore.QRect(1620, 520, 101, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_11.setFont(font)
        self.label_11.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_11.setObjectName("label_11")
        self.label_12 = QtWidgets.QLabel(self.centralwidget)
        self.label_12.setGeometry(QtCore.QRect(1580, 800, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_12.setFont(font)
        self.label_12.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_12.setObjectName("label_12")
        self.label_13 = QtWidgets.QLabel(self.centralwidget)
        self.label_13.setGeometry(QtCore.QRect(1580, 330, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_13.setFont(font)
        self.label_13.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_13.setObjectName("label_13")
        self.label_14 = QtWidgets.QLabel(self.centralwidget)
        self.label_14.setGeometry(QtCore.QRect(1580, 230, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_14.setFont(font)
        self.label_14.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_14.setObjectName("label_14")
        self.label_15 = QtWidgets.QLabel(self.centralwidget)
        self.label_15.setGeometry(QtCore.QRect(1580, 600, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_15.setFont(font)
        self.label_15.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_15.setObjectName("label_15")
        self.label_16 = QtWidgets.QLabel(self.centralwidget)
        self.label_16.setGeometry(QtCore.QRect(1580, 430, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_16.setFont(font)
        self.label_16.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_16.setObjectName("label_16")
        self.label_17 = QtWidgets.QLabel(self.centralwidget)
        self.label_17.setGeometry(QtCore.QRect(1580, 700, 41, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_17.setFont(font)
        self.label_17.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_17.setObjectName("label_17")
        self.label_18 = QtWidgets.QLabel(self.centralwidget)
        self.label_18.setGeometry(QtCore.QRect(1520, 50, 291, 71))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_18.setFont(font)
        self.label_18.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 50px;")
        self.label_18.setObjectName("label_18")
        self.lcdNumber = QtWidgets.QLCDNumber(self.centralwidget)
        self.lcdNumber.setGeometry(QtCore.QRect(1620, 220, 101, 61))
        font = QtGui.QFont()
        font.setFamily("Roboto")
        font.setPointSize(23)
        self.lcdNumber.setFont(font)
        self.lcdNumber.setStyleSheet("border: 1px solid rgb(50, 50, 50);")
        self.lcdNumber.setObjectName("lcdNumber")
        self.lcdNumber_2 = QtWidgets.QLCDNumber(self.centralwidget)
        self.lcdNumber_2.setGeometry(QtCore.QRect(1620, 320, 101, 61))
        font = QtGui.QFont()
        font.setFamily("Roboto")
        font.setPointSize(23)
        self.lcdNumber_2.setFont(font)
        self.lcdNumber_2.setStyleSheet("border: 1px solid rgb(50, 50, 50);")
        self.lcdNumber_2.setObjectName("lcdNumber_2")
        self.lcdNumber_3 = QtWidgets.QLCDNumber(self.centralwidget)
        self.lcdNumber_3.setGeometry(QtCore.QRect(1620, 420, 101, 61))
        font = QtGui.QFont()
        font.setFamily("Roboto")
        font.setPointSize(23)
        self.lcdNumber_3.setFont(font)
        self.lcdNumber_3.setStyleSheet("border: 1px solid rgb(50, 50, 50);")
        self.lcdNumber_3.setObjectName("lcdNumber_3")
        self.lcdNumber_4 = QtWidgets.QLCDNumber(self.centralwidget)
        self.lcdNumber_4.setGeometry(QtCore.QRect(1620, 590, 101, 61))
        font = QtGui.QFont()
        font.setFamily("Roboto")
        font.setPointSize(23)
        self.lcdNumber_4.setFont(font)
        self.lcdNumber_4.setStyleSheet("border: 1px solid rgb(50, 50, 50);")
        self.lcdNumber_4.setObjectName("lcdNumber_4")
        self.lcdNumber_5 = QtWidgets.QLCDNumber(self.centralwidget)
        self.lcdNumber_5.setGeometry(QtCore.QRect(1620, 690, 101, 61))
        font = QtGui.QFont()
        font.setFamily("Roboto")
        font.setPointSize(23)
        self.lcdNumber_5.setFont(font)
        self.lcdNumber_5.setStyleSheet("border: 1px solid rgb(50, 50, 50);")
        self.lcdNumber_5.setObjectName("lcdNumber_5")
        self.lcdNumber_6 = QtWidgets.QLCDNumber(self.centralwidget)
        self.lcdNumber_6.setGeometry(QtCore.QRect(1620, 790, 101, 61))
        font = QtGui.QFont()
        font.setFamily("Roboto")
        font.setPointSize(23)
        self.lcdNumber_6.setFont(font)
        self.lcdNumber_6.setStyleSheet("border: 1px solid rgb(50, 50, 50);")
        self.lcdNumber_6.setObjectName("lcdNumber_6")
        self.pushButton_9 = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_9.setGeometry(QtCore.QRect(240, 460, 161, 51))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.pushButton_9.setFont(font)
        self.pushButton_9.setStyleSheet("QPushButton {\n"
"    font-size: 20px;\n"
"    background-color: rgb(200, 200, 200);\n"
"}\n"
"\n"
"QPushButton:hover {\n"
"    background-color: rgb(150, 150, 150);\n"
"}\n"
"")
        self.pushButton_9.setObjectName("pushButton_9")
        self.label_5 = QtWidgets.QLabel(self.centralwidget)
        self.label_5.setGeometry(QtCore.QRect(200, 300, 261, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_5.setFont(font)
        self.label_5.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_5.setObjectName("label_5")
        self.pushButton_10 = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_10.setGeometry(QtCore.QRect(240, 720, 161, 51))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.pushButton_10.setFont(font)
        self.pushButton_10.setStyleSheet("QPushButton {\n"
"    font-size: 20px;\n"
"    background-color: rgb(200, 200, 200);\n"
"}\n"
"\n"
"QPushButton:hover {\n"
"    background-color: rgb(150, 150, 150);\n"
"}\n"
"")
        self.pushButton_10.setObjectName("pushButton_10")
        self.label_19 = QtWidgets.QLabel(self.centralwidget)
        self.label_19.setGeometry(QtCore.QRect(640, 30, 761, 211))
        self.label_19.setText("")
        self.label_19.setPixmap(QtGui.QPixmap("../robot/logo.png"))
        self.label_19.setObjectName("label_19")
        self.comboBox = QtWidgets.QComboBox(self.centralwidget)
        self.comboBox.setGeometry(QtCore.QRect(180, 220, 181, 41))
        self.comboBox.setStyleSheet("background-color: white;")
        self.comboBox.setObjectName("comboBox")
        self.label_9 = QtWidgets.QLabel(self.centralwidget)
        self.label_9.setGeometry(QtCore.QRect(210, 150, 241, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_9.setFont(font)
        self.label_9.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_9.setObjectName("label_9")
        self.pushButton_11 = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_11.setGeometry(QtCore.QRect(380, 220, 101, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.pushButton_11.setFont(font)
        self.pushButton_11.setStyleSheet("QPushButton {\n"
"    font-size: 20px;\n"
"    background-color: rgb(200, 200, 200);\n"
"}\n"
"\n"
"QPushButton:hover {\n"
"    background-color: rgb(150, 150, 150);\n"
"}\n"
"")
        self.pushButton_11.setObjectName("pushButton_11")
        self.pushButton_12 = QtWidgets.QPushButton(self.centralwidget)
        self.pushButton_12.setGeometry(QtCore.QRect(930, 870, 161, 51))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.pushButton_12.setFont(font)
        self.pushButton_12.setStyleSheet("QPushButton {\n"
"    font-size: 20px;\n"
"    background-color: rgb(200, 200, 200);\n"
"}\n"
"\n"
"QPushButton:hover {\n"
"    background-color: rgb(150, 150, 150);\n"
"}\n"
"")
        icon = QtGui.QIcon()
        icon.addPixmap(QtGui.QPixmap("../robot/home.png"), QtGui.QIcon.Normal, QtGui.QIcon.Off)
        self.pushButton_12.setIcon(icon)
        self.pushButton_12.setObjectName("pushButton_12")
        self.horizontalSlider = QtWidgets.QSlider(self.centralwidget)
        self.horizontalSlider.setGeometry(QtCore.QRect(150, 830, 311, 22))
        self.horizontalSlider.setStyleSheet("/* Estilo del slider */\n"
"QSlider::groove:horizontal {\n"
"    border: 1px solid rgb(250, 250, 250); /* #999999 en RGB */\n"
"    height: 2px;\n"
"    background: rgb(250, 250, 250); /* #b0b0b0 en RGB */\n"
"    margin: 2px 0;\n"
"    border-radius: 4px;\n"
"}\n"
"\n"
"QSlider::handle:horizontal {\n"
"    background: rgb(102, 204, 255); /* #66ccff en RGB */\n"
"    border: 1px solid rgb(92, 92, 92); /* #5c5c5c en RGB */\n"
"    width: 18px;\n"
"    height: 18px;\n"
"    border-radius: 9px;\n"
"    margin: -5px 0; /* Para ajustar la posición vertical del handle */\n"
"}\n"
"\n"
"QSlider::sub-page:horizontal {\n"
"    background: rgb(102, 204, 255); /* #66ccff en RGB */\n"
"    border: 1px solid rgb(119, 119, 119); /* #777 en RGB */\n"
"    height: 8px;\n"
"    border-radius: 4px;\n"
"}\n"
"\n"
"QSlider::add-page:horizontal {\n"
"    background: rgb(176, 176, 176); /* #b0b0b0 en RGB */\n"
"    border: 1px solid rgb(119, 119, 119); /* #777 en RGB */\n"
"    height: 8px;\n"
"    border-radius: 4px;\n"
"}\n"
"")
        self.horizontalSlider.setOrientation(QtCore.Qt.Horizontal)
        self.horizontalSlider.setObjectName("horizontalSlider")
        self.label_20 = QtWidgets.QLabel(self.centralwidget)
        self.label_20.setGeometry(QtCore.QRect(250, 850, 151, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_20.setFont(font)
        self.label_20.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_20.setObjectName("label_20")
        self.label_21 = QtWidgets.QLabel(self.centralwidget)
        self.label_21.setGeometry(QtCore.QRect(280, 890, 31, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_21.setFont(font)
        self.label_21.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_21.setObjectName("label_21")
        self.label_22 = QtWidgets.QLabel(self.centralwidget)
        self.label_22.setGeometry(QtCore.QRect(320, 890, 31, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_22.setFont(font)
        self.label_22.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 30px;")
        self.label_22.setObjectName("label_22")
        self.label_23 = QtWidgets.QLabel(self.centralwidget)
        self.label_23.setGeometry(QtCore.QRect(10, 0, 191, 41))
        font = QtGui.QFont()
        font.setPointSize(-1)
        self.label_23.setFont(font)
        self.label_23.setStyleSheet("color: rgb(50, 50, 50);\n"
"font-size: 20px;")
        self.label_23.setObjectName("label_23")
        MainWindow.setCentralWidget(self.centralwidget)
        self.menubar = QtWidgets.QMenuBar(MainWindow)
        self.menubar.setGeometry(QtCore.QRect(0, 0, 1903, 26))
        self.menubar.setObjectName("menubar")
        MainWindow.setMenuBar(self.menubar)
        self.statusbar = QtWidgets.QStatusBar(MainWindow)
        self.statusbar.setObjectName("statusbar")
        MainWindow.setStatusBar(self.statusbar)

        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)

        #Comienza mi lógica    
        dpi = 100  #Puedes ajustar esto según la configuración de tu pantalla
        width_in_inches = 750 / dpi
        height_in_inches = 750 / dpi
        self.figure = Figure(figsize=(width_in_inches, height_in_inches), dpi=dpi)
        self.figure.patch.set_facecolor((230/255, 230/255, 230/255))  # Color RGB (250, 250, 250)

        #Matplotlib Figure
        self.canvas = FigureCanvas(self.figure)
        self.canvas.setParent(self.frame)
        self.ax = self.figure.add_subplot(111, projection='3d') 
        self.ax.set_facecolor((230/255, 230/255, 230/255))  # Color RGB (250, 250, 250)

        #Set plot limits
        self.ax.set_xlim(-400, 400)
        self.ax.set_ylim(-400, 400)
        self.ax.set_zlim(0, 400)
                    
        #Configurar QTimer
        self.timer = QtCore.QTimer()
        self.timer.setInterval(5000)  # Intervalo de 5 segundos
        self.timer.timeout.connect(self.update_serial_ports)
        self.timer.start()
                    
        self.update_serial_ports()  # Llama a la función inicialmente para llenar el comboBox
                    
        # Botón para conectar a Arduino
        self.pushButton_11.clicked.connect(self.connect_to_arduino)
        self.arduino = None

        # Para calibrar
        self.pushButton_12.clicked.connect(self.send_calibration_command)
                    
        self.retranslateUi(MainWindow)
        QtCore.QMetaObject.connectSlotsByName(MainWindow)
                            
        # Más configuración ...

    def send_calibration_command(self):
        if self.arduino and self.arduino.is_open:
            self.arduino.write(b"CALIBRATE\n")
            print("Sent 'CALIBRATE' command to Arduino")
        else:
            print("Arduino is not connected or the port is closed.")
                    
    def connect_to_arduino(self):
        if self.arduino:
                self.arduino.close()  # Cierra la conexión existente si hay una
        try:
                selected_port = self.comboBox.currentText()
                self.arduino = serial.Serial(selected_port, 115200, timeout=1)
                print("Connected to Arduino on", selected_port)
        except serial.SerialException as e:
                print("Failed to connect:", e)
                    
    def update_serial_ports(self):
        # Busca los puertos seriales disponibles
        current_ports = [self.comboBox.itemText(i) for i in range(self.comboBox.count())]
        found_ports = [port.device for port in serial.tools.list_ports.comports()]
                            
        # Agregar nuevos puertos
        for port in found_ports:
                if port not in current_ports:
                        self.comboBox.addItem(port)
                            
        # Eliminar puertos desconectados
        for port in current_ports:
                if port not in found_ports:
                        index = self.comboBox.findText(port)
                        self.comboBox.removeItem(index)

    def retranslateUi(self, MainWindow):
        _translate = QtCore.QCoreApplication.translate
        MainWindow.setWindowTitle(_translate("MainWindow", "Robot Controller"))
        self.checkBox.setText(_translate("MainWindow", "Draw tool path"))
        self.label.setText(_translate("MainWindow", "Inverse kinematics"))
        self.label_2.setText(_translate("MainWindow", "Xf"))
        self.label_3.setText(_translate("MainWindow", "Yf"))
        self.label_4.setText(_translate("MainWindow", "Zf"))
        self.label_6.setText(_translate("MainWindow", "θ<sub>2<sub>"))
        self.label_7.setText(_translate("MainWindow", "θ<sub>1</sub>"))
        self.label_8.setText(_translate("MainWindow", "θ<sub>3<sub>"))
        self.label_10.setText(_translate("MainWindow", "End effector"))
        self.label_11.setText(_translate("MainWindow", "Angles"))
        self.label_12.setText(_translate("MainWindow", "θ<sub>3<sub>"))
        self.label_13.setText(_translate("MainWindow", "Yf"))
        self.label_14.setText(_translate("MainWindow", "Xf"))
        self.label_15.setText(_translate("MainWindow", "θ<sub>1</sub>"))
        self.label_16.setText(_translate("MainWindow", "Zf"))
        self.label_17.setText(_translate("MainWindow", "θ<sub>2<sub>"))
        self.label_18.setText(_translate("MainWindow", "Current pose"))
        self.pushButton_9.setText(_translate("MainWindow", "Move robot"))
        self.label_5.setText(_translate("MainWindow", "Forward kinematics"))
        self.pushButton_10.setText(_translate("MainWindow", "Move robot"))
        self.label_9.setText(_translate("MainWindow", "Select robot port"))
        self.pushButton_11.setText(_translate("MainWindow", "Connect"))
        self.pushButton_12.setText(_translate("MainWindow", "Move home"))
        self.label_20.setText(_translate("MainWindow", "Set speed"))
        self.label_21.setText(_translate("MainWindow", "10"))
        self.label_22.setText(_translate("MainWindow", "%"))
        self.label_23.setText(_translate("MainWindow", "Version: Alpha 1.0.0"))


if __name__ == "__main__":
    import sys
    app = QtWidgets.QApplication(sys.argv)
    MainWindow = QtWidgets.QMainWindow()
    ui = Ui_MainWindow()
    ui.setupUi(MainWindow)
    MainWindow.show()
    sys.exit(app.exec_())
